﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DataExchange
{
    public partial class FormMain : Form, IFavoriteColor
    {
        public FormMain()
        {
            InitializeComponent();
        }

        private void buttonModal_Click(object sender, EventArgs e)
        {
            using (Form dlg = new DlgOptions())
            {
                IFavoriteColor favDlg = (IFavoriteColor)dlg;
                favDlg.FavoriteColor = this.FavoriteColor;
                dlg.ShowDialog();
                this.FavoriteColor = favDlg.FavoriteColor;
                this.buttonModal.BackColor = this.FavoriteColor;
            }
        }

        #region IFavoriteColor Members

        public Color FavoriteColor
        {
            get
            {
                return Properties.Settings.Default.Color;
            }
            set
            {
                Properties.Settings.Default.Color = value;
            }
        }

        #endregion

        private void FormMain_Load(object sender, EventArgs e)
        {
            this.buttonModal.BackColor = this.FavoriteColor;
            this.buttonModeless.BackColor = this.FavoriteColor;
        }

        private void buttonModeless_Click(object sender, EventArgs e)
        {
            DlgOptions dlg = new DlgOptions();
            IFavoriteColor favDlg = (IFavoriteColor)dlg;                
            favDlg.FavoriteColor = this.FavoriteColor;
            dlg.Apply += new EventHandler(favDlg_Apply);
            dlg.Show(this);
        }

        void favDlg_Apply(object sender, EventArgs e)
        {
            IFavoriteColor favDlg = (IFavoriteColor)sender;
            this.FavoriteColor = favDlg.FavoriteColor;
            this.buttonModeless.BackColor = this.FavoriteColor;   
        }

        private void FormMain_FormClosed(object sender, FormClosedEventArgs e)
        {
            Properties.Settings.Default.Save();
        }
    }
}
