using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace Dialogs
{
	public class LoanApplicationValidated : Dialogs.LoanApplicationDialog
	{
		protected System.Windows.Forms.ErrorProvider errorProvider;
		protected Regex re;

		public LoanApplicationValidated()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			re = new Regex(@"^\d{3}([ -.]?)\d{3}(\1)\d{4}$");
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.errorProvider = new System.Windows.Forms.ErrorProvider();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Name = "label1";
			// 
			// applicantNameTextBox
			// 
			this.applicantNameTextBox.Name = "applicantNameTextBox";
			this.applicantNameTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.applicantNameTextBox_Validating);
			// 
			// okButton
			// 
			this.okButton.CausesValidation = true;
			this.okButton.Name = "okButton";
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(232, 152);
			this.cancelButton.Name = "cancelButton";
			// 
			// label2
			// 
			this.label2.Name = "label2";
			// 
			// label3
			// 
			this.label3.Name = "label3";
			// 
			// applicantPhoneNoTextBox
			// 
			this.applicantPhoneNoTextBox.Name = "applicantPhoneNoTextBox";
			this.applicantPhoneNoTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.applicantPhoneNoTextBox_Validating);
			// 
			// applicantLoanAmountTextBox
			// 
			this.applicantLoanAmountTextBox.Name = "applicantLoanAmountTextBox";
			this.applicantLoanAmountTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.applicantLoanAmountTextBox_Validating);
			// 
			// groupBox1
			// 
			this.groupBox1.Name = "groupBox1";
			// 
			// buttonApply
			// 
			this.buttonApply.CausesValidation = true;
			this.buttonApply.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonApply.Name = "buttonApply";
			// 
			// errorProvider
			// 
			this.errorProvider.ContainerControl = this;
			// 
			// LoanApplicationValidated
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = null;
			this.ClientSize = new System.Drawing.Size(336, 190);
			this.Name = "LoanApplicationValidated";
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

//		protected virtual void InitializeDerived() 
//		{
//			applicantNameTextBox.Validating += new CancelEventHandler(applicantNameTextBox_Validating);
//			applicantPhoneNoTextBox.Validating += new CancelEventHandler(applicantPhoneNoTextBox_Validating);
//			applicantLoanAmountTextBox.Validating += new CancelEventHandler(applicantLoanAmountTextBox_Validating);
//		}

		protected virtual void applicantNameTextBox_Validating(object sender, CancelEventArgs e)
		{
			String error = "";
			if (!IsClosing && applicantNameTextBox.Text.Length == 0) 
			{
				error = "Please enter a name";
				e.Cancel = true;
			}
			errorProvider.SetError(applicantNameTextBox, error);
		}

		protected virtual void applicantLoanAmountTextBox_Validating(object sender, CancelEventArgs e)
		{
			String error = "";
			if (!IsClosing) 
			{
				try
				{
					Convert.ToDouble( applicantLoanAmountTextBox.Text );
				}
				catch( Exception )
				{
					error = "Please enter a number";
					e.Cancel = true;
				}
			}
			errorProvider.SetError(applicantLoanAmountTextBox, error);
		}

		protected virtual void applicantPhoneNoTextBox_Validating(object sender, CancelEventArgs e)
		{
			String error = "";
			if (!IsClosing && !re.IsMatch(applicantPhoneNoTextBox.Text)) 
			{
				error = "Please enter a US phone number";
				e.Cancel = true;
			}
			errorProvider.SetError(applicantPhoneNoTextBox, error);
		}

	}
}

